/* fingerd.c written by Dylan Northrup.  Networking code was ruthlessly stolen
   from a basic identd written by cdrovers@calum.csclub.uwaterloo.ca of which 
   portions were written by rridge@calum.csclub.uwaterloo.ca.  I also adapted the
   file input stuff from a command line finger client written by Mark Elrod.
	All the rest of this crap is mine ALL MINE YOU HEAR!!!! :-)
   
   This code is freely available and useable by all as long as this commented
   section is included in it's entirety.

Revision History
	0.7 	- First release
	0.7.5	- Moved file reading into seperate function
	0.7.6	- Recognises which user is fingered and returns
			  information based on whether a user was fingered or just
			  the machine
			- Added system information (instead of just "this is where the
			  system information will go")
	0.7.7	- Recognises specific username.
			- Returns file based on username.
			- Added case where incorrect username is requested.
	0.8		- Version submitted for BeOS Masters contest on 23 July 1997

To be done

	- This thing needs to be multi-threaded.  Gotta figure out how to pass 
	  the filehandle and the username easily.  There has to be a way to 
	  easily pass an open filehandle to a spawn'd thread.  If anyone knows
	  how, please drop me a line!
	- Gotta figure out how to get stuff like CPU usage and memory usage 
	  Also, need to get with the time converstion utilities and make the
	  system output uptime information.  Just don't want to deal with this
	  at the moment though.
*/

#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include <errno.h>
#include <signal.h>
#include <string.h>
#include <unistd.h>

#include <sys/types.h>
#include <netdb.h>
#include <sys/time.h>

#define FINGERPORT 79

//#define DEBUG

const int BUFFER_SIZE = (16 * 1024);	// Used for buffering finger
										// file information.

char* retrv_system_info();
char* read_file(char *filename);
int do_bind(char const *service, long def);
void fingerd();

int
do_bind(char const *service, long def) {
	int ifd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	long port;
	static struct sockaddr_in name;

	if (ifd == -1) {
		return -1;
	}

	if (service == NULL) {
		port = def;
	} else {
		struct servent *serv = getservbyname(service, "tcp");
		if (serv == NULL) {
			port = atoi(service);
			if (port == 0) {
				errno = ESRCH;
				return -1;
			}
		} else {
			port = ntohs(serv->s_port);
		}
	}
	
	name.sin_family = AF_INET;
	name.sin_port = htons(port);
	name.sin_addr.s_addr = htonl(INADDR_ANY);
	memset(name.sin_zero, 0, sizeof name.sin_zero);
	
	if (bind(ifd, (struct sockaddr *) &name, sizeof name) == -1) {
		return -1;
	}
#ifdef DEBUG
	cout << "bound port " << (long) port << "\n";
#endif
	if (listen(ifd, 4) == -1) {
		return -1;
	}
#ifdef DEBUG
	cout << "listening...\n";
#endif
	return ifd;
}

void
fingerd () {
	int fd, ifd;
	int tmp;
	int n,r, done;
	int error;
	struct sockaddr_in name;
	char buf[2048], temp[2048], *buffer;
	const int TMP_NUM_MAX = 60000;

	fd = do_bind(NULL, FINGERPORT);

	if (fd == -1) {
		perror("do_bind");
		return;
	}

	while(1) {
		tmp = sizeof name;
		ifd = accept(fd, (struct sockaddr *) &name, &tmp);
		if (ifd == -1) {
			perror("accept");
			return;
		}
		// Here's all the previously written identd code.
		// Let's see if I can bend it to do what I wish...
		n = 0;
		error =0;	
		done = 0;
		while (!done) { 
			// Get the information they sent
			r = recv(ifd, &buf[n], (sizeof buf ) - n, 0);
			// Check to see if they sent something incredibly
			// huge or if they don't send anything at all.
			// If so, there's a problem.
			if ((r < 1) || (r > 2046)) {
				error = 1;
				done = 1;
			} else {
				n = n + r;
				// Check to see if we get the \r\n pair we're 
				// looking for.
				if (n > 1) {
					if ((buf[n-1] == 10) && (buf[n-2] == 13)) {
						done =1;
					}
				}	
			}
		}
		// Take the buffer filled with crap that was sent and put it
		// in an array we can work with. Last two bits of buf will
		// be the \r\n pair.
		for(int i=0; i < (n-2); i++){ temp[i]=buf[i]; }
		temp[n-2] = 0x00;	// Append the null
#ifdef DEBUG
		cout << "They gave us " << (char *)temp << "\n";
#endif
		// New code!
		if (!error) {
			// Check to see if they sent a username.
			if (n < 3){
				buffer = retrv_system_info();
			} else {
				// Get file information from sub
				char path[2048] = "/boot/home/plans/";
				strcat(path,(char *)temp);
				buffer = read_file(path);
			}
			// Then send off the file through the socket
			send(ifd, buffer, strlen(buffer), 0);
		}
		closesocket(ifd);
	}
}

char*
retrv_system_info(){
	char system_buf[BUFFER_SIZE];
	char *buf_ptr = system_buf;
	char temp_line[81];
	system_info *sys_info = NULL;
	sys_info = (system_info*)malloc(sizeof(system_info));
	status_t dummy;
	int temp;
	
	dummy = get_system_info(sys_info);

	// Initialise the buffer (if not reset, it just grows and grows
	system_buf[0] = 0x00;

	// serial number info
	sprintf(temp_line,"BeBox Serial Number: %x:%x\n", sys_info->id[0],
		sys_info->id[1]);
	strcat(system_buf, temp_line);
	// Processor info (number, type and speed)
	sprintf(temp_line, "This machine has %x ", sys_info->cpu_count);
	strcat(system_buf, temp_line);
	switch(sys_info->cpu_type){
		case B_CPU_PPC_601:
			sprintf(temp_line, "Power PC 601");
			strcat(system_buf, temp_line);
			break;
		case B_CPU_PPC_603:
			sprintf(temp_line, "Power PC 603");
			strcat(system_buf, temp_line);
			break;
		case B_CPU_PPC_603e:
			sprintf(temp_line, "Power PC 603e");
			strcat(system_buf, temp_line);
			break;
		case B_CPU_PPC_604:
			sprintf(temp_line, "Power PC 604");
			strcat(system_buf, temp_line);
			break;
		case B_CPU_PPC_604e:
			sprintf(temp_line, "Power PC 604e");
			strcat(system_buf, temp_line);
			break;
		case B_CPU_PPC_686:
			sprintf(temp_line, "Power PC 686");
			strcat(system_buf, temp_line);
			break;
		default:
			break;
	}
	if(sys_info->cpu_count > 1){
		sprintf(temp_line, " processors running at ");
		strcat(system_buf, temp_line);
	} else {
		sprintf(temp_line, " processor running at ");
		strcat(system_buf, temp_line);
	}
	temp = sys_info->cpu_clock_speed / 1000000;
	sprintf(temp_line,"%d MHz\n", temp);
	strcat(system_buf, temp_line);
	// Kernel information
	sprintf(temp_line,"Kernel Name: %s\n",sys_info->kernel_name);
	strcat(system_buf, temp_line);
	sprintf(temp_line, "Kernel Build date\\time: %s %s",
		sys_info->kernel_build_date, sys_info->kernel_build_time);
	strcat(system_buf, temp_line);
	
	return(buf_ptr);
}

char*
read_file(char *filename){
	// This whole thing reads in a bit of the file and dynamically resizes
	// the buffer until it's done.
	FILE *finger_file;
	char *file_buf = NULL;
	int current_buffer_size = BUFFER_SIZE;
	file_buf = (char*)malloc(BUFFER_SIZE);
	int total = 0;
	int tmp_num = 0;
	
	finger_file = fopen(filename,"r");
	
	if(finger_file == NULL){
		char temp_line[81] = "No plan defined for that user\n";
		strcat(file_buf, temp_line);
		return(file_buf);
	}
			
	while(1){
		char file_buffer[1024];
		
		int count = fread(file_buffer, sizeof (char), BUFFER_SIZE, finger_file);
		
		if (count > 0){
			memcpy(file_buf + total, file_buffer, count);
			total += count;
			if((current_buffer_size - total) <= 1024){
				file_buf = (char*)realloc(file_buf,current_buffer_size + 1024);
				current_buffer_size += 1024;
			}
		} else {
			*(file_buf + total) = 0x00;
			break;
		}
	}
	
	tmp_num = fclose(finger_file);		// We should be through with this now.
	return(file_buf);
}
int
main(int, char **argv) {
	fingerd();
	return 0;
}
